<?php
	session_save_path("sess");
        session_start(); 
	$error_message="";

	if(!isset($_SESSION['secrets']))$_SESSION['secrets']=array();
	// Fix for CSRF: Create a random page token, 
	// store it in the session, include it in all forms,
	// as a hidden variable, and verify it on each submit.

	if(isset($_REQUEST['submitSecret'])){
		if(isset($_SESSION["page_token"]) && $_REQUEST["page_token"]==$_SESSION["page_token"]){
			$_SESSION['secrets'][]=$_REQUEST["newSecret"];
		} else {
			$error_message="Page expired, operation ignored.";
		}
	}
	$_SESSION["page_token"]=rand();
?>
<html>
	<body>
		<?php echo($error_message); ?>
		<form> 
			Secret: <input size="10" type="text" name="newSecret"/>
			<input type="submit" name="submitSecret" value="add to my secrets" />
			<input type="hidden" name="page_token" value="<?php echo($_SESSION["page_token"]); ?>" />
		</form>
		<h3>My Secrets</h3>
		<ul>
		<?php
			foreach($_SESSION['secrets'] as $value ){
				echo("<li> $value </li>");
			}
		?>
		</ul>
		<a href="secrets.php">Refresh</a>
	</body>
</html>
